/**
 * ページ情報ダイアログ
 */
var UnMHTPageInfo = {
  protocolHandler : null,        /* arUnMHTMhtmlProtocolHandler
                                  *   unmht プロトコルハンドラ */
  
  messages : null,               /* nsIStringBundle  メッセージ */
  
  /**
   * ウィンドウが開かれたイベント
   */
  onLoad : function () {
    var urltext = document.getElementById ("urltext");
    if (!urltext) {
      return;
    }
    
    var rows = null;
    var urlRow = null;
    var node = urltext;
    while (node) {
      if (node.nodeName.match (/rows/)) {
        rows = node;
        break;
      }
      if (node.nodeName.match (/row/)) {
        urlRow = node;
      }
      node = node.parentNode;
    }
    
    if (!rows) {
      return;
    }
    if (!urlRow) {
      return;
    }
    
    var url = gDocument.location.toString ();
    
    var entries
    = Components.classes ["@mozilla.org/appshell/window-mediator;1"]
    .getService (Components.interfaces.nsIWindowMediator)
    .getEnumerator ("navigator:browser");
    
    UnMHTPageInfo.protocolHandler
    = Components.classes ["@mozilla.org/network/protocol;1?name=unmht"]
      .getService (Components.interfaces.arIUnMHTProtocolHandler);
    
    if (!UnMHTPageInfo.protocolHandler.isUnMHTURI (url)) {
      return;
    }
    
    var entries
    = Components.classes ["@mozilla.org/appshell/window-mediator;1"]
    .getService (Components.interfaces.nsIWindowMediator)
    .getEnumerator ("navigator:browser");
    
    var file = null;
    while (entries.hasMoreElements ()) {
      var w = entries.getNext ();
      
      file = w.UnMHT.getFile (url);
      if (file) {
        break;
      }
    }
    
    if (!file) {
      return;
    }
    
    UnMHTPageInfo.messages
    = Components.classes ["@mozilla.org/intl/stringbundle;1"]
    .getService (Components.interfaces.nsIStringBundleService)
    .createBundle ("chrome://unmht/locale/unmht.properties");
    
    var row = document.createElement ("row");
    var label = document.createElement ("label");
    label.setAttribute ("control", "unmht-original-url");
    label.setAttribute
    ("value", UnMHTPageInfo.messages.GetStringFromName ("original_uri"));
    var sep = document.createElement ("separator");
    var textbox = document.createElement ("textbox");
    textbox.setAttribute ("readonly", "unmht-original-url");
    textbox.setAttribute ("id", "unmht-original-url");
    textbox.setAttribute ("value", file.contentLocation);
    row.appendChild (label);
    row.appendChild (sep);
    row.appendChild (textbox);
    
    if (urlRow.nextSibling) {
      rows.insertBefore (row, urlRow.nextSibling);
    }
    else {
      rows.appendChild (row);
    }
  }
}

window.addEventListener ("load",
                         function () {
                           UnMHTPageInfo.onLoad ();
                         }, false);
