/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * 追加ファイルダイアログの本体
 */
var UnMHTAdditional = {
  param : null, /* Object  パラメータ
                 *   コールバックが定義されている */
    
  /**
   * 初期化処理
   */
  init : function () {
    UnMHTAdditional.param = window.arguments [0];
  },
    
  /**
   * OK ボタンのイベント
   */
  accept : function () {
    var param = UnMHTAdditional.param;
    var additionalFiles;
        
    additionalFiles = new Array ();
    var text = document.getElementById ("files").value;
    var lines = text.split (/[\r\n]/);
    for (var i = 0; i < lines.length; i ++) {
      if (lines [i]
          && lines [i].match (/^[ \t]*(.+:\/\/[^ \t]+)[ \t]*$/)) {
        additionalFiles.push (RegExp.$1);
      }
    }
        
    if ("callback" in param) {
      param.callback (additionalFiles);
    }
        
    return true;
  },
    
  /**
   * キャンセルボタンのイベント
   */
  cancel : function () {
    return true;
  }
};